/* NS1 - Nick Services ns-src/add_functions.c
 * NS1.2 Copyright  1998-2000 Chris Birch(IRCore)
 */

#include <bot.h>

int is_auth(char *who)
{
   struct nickinfo *curr;
   struct rnickinfo *rnick;
   struct adderinfo *adder;
   char *nick, *passwd, *uhost = NULL, *nwho = NULL;
   int gotone = 0;
 
   nwho = nick2num(who);
   uhost = getuserhost(who);
   curr = return_nickinfo(who);

   rnick = rnickhead;
   while(rnick != NULL)
   {
      if(!strcasecmp(who, rnick->nick))
      {
                if (rnick->authed && !strcmp(rnick->numeric, curr->numeric))
                {
                   return 1;
                }
                else return 0;
      }
      rnick = rnick->next;
   }
   return 0;
}

int is_admin(char *who)
{
   struct rnickinfo *rnick;
   struct adderinfo *adder;
   char *nick, *passwd, *uhost = NULL, *nwho = NULL;
 
   nwho = nick2num(who);
   rnick = rnickhead;
   uhost = getuserhost(who);

   while(rnick != NULL)
   {
      if(!strcasecmp(who, rnick->nick))
      {
         adder = rnick->adderhead;
         while(adder != NULL)
         {
            if(!bancmp(adder->address, uhost))
            {
                if (rnick->admin)
                {
                   return 1;
                }
                else return 0;
            }
            adder = adder->next;
         }
      }
      rnick = rnick->next;
   }
   return 0;
}



void admin_drop(char *who, char *rest)
{
   char *nwho = NULL;
   char *dropnick = NULL;
   struct rnickinfo *rnick;
 
   nwho = nick2num(who);
   if(strlen(rest) > 100) return;
   if (!is_auth(who))
   {
      send_to_server(":%s NOTICE %s : You are not authorized to use that command.\n", bot.nick, nwho);
      return;
   }
   if (!rest)
   {
      send_to_server(":%s NOTICE %s : Give the nickname you wish to drop.\n", bot.nick, nwho);
      return;
   }

   dropnick = strtok(rest, " ");
   rnick = rnickhead;
   while(rnick != NULL)
   {
      if(!strcasecmp(dropnick, rnick->nick))
      {
         delete_rnode(dropnick);
         send_to_server(":%s NOTICE %s : Nick %s has been dropped\n", bot.nick, nwho, dropnick);
         write_rnickfile();
         return;
      }
      rnick=rnick->next;
   }
   send_to_server(":%s NOTICE %s : Nick %s is not Registered.\n", bot.nick, nwho, dropnick);
}


void newpass(char *who, char *rest)
{
   char *nwho = NULL;
   char *newpass = NULL;
   char *uhost = NULL, *cryptpass;
   struct rnickinfo *rnick;
   struct adderinfo *adder;
   int gotone = 0;
 
   if(strlen(rest) > 100) return;
   nwho = nick2num(who);
   if (!is_auth(who))
   {
      send_to_server(":%s NOTICE %s : You need to be AUTH'd with %s first.\n", bot.nick, nwho, bot.nick);
      return;
   }
   newpass = strtok(rest, " ");
   if (newpass == NULL)
   {
      send_to_server(":%s NOTICE %s : You need to include your new password\n", bot.nick, nwho);
      return;
   }
   if(strlen(newpass) > 8)
   {
       send_to_server(":%s NOTICE %s :Password can only be 8 characters\n", bot.nick, nwho);
       send_to_server(":%s NOTICE %s :Password NOT Changed\n", bot.nick, nwho);
       return;
   }
   rnick = rnickhead;
   while(rnick != NULL)
   {
      if(!strcasecmp(who, rnick->nick))
      {
          cryptpass = mkpass(newpass, "0");
          strcpy(rnick->pass, cryptpass);
          send_to_server(":%s NOTICE %s : Password changed for %s to %s \n", bot.nick, nwho, rnick->nick, newpass);
          write_rnickfile();
          return;
      }
      rnick=rnick->next;
   }
}



void add_mask(char *who, char *rest)
{
   struct rnickinfo *rnick;
   struct adderinfo *adder;
   char *usrhost, *nwho, taddr[1000], *ptr;
   int testmask = 0, cnt = 0;

   nwho = nick2num(who);
   if(strlen(rest) > 100) return;
   usrhost = strtok(rest, " ");
   if (!is_auth(who))
   {
      send_to_server(":%s NOTICE %s : You need to be AUTH'd with %s first.\n", bot.nick, nwho, bot.nick);
      return;
   }
   if(strchr(usrhost, '!'))
   {
      send_to_server(":%s NOTICE %s :Incorrect syntax! Format is user@hostmask\n", bot.nick, nwho);
      return;
   }
   if(!strchr(usrhost, '@'))
   {
      send_to_server(":%s NOTICE %s :Incorrect syntax! Format is user@hostmask\n", bot.nick, nwho);
      return;
   }
   strcpy(taddr, usrhost);
   if(ptr = strchr(taddr, '@')) *ptr++ = '\0';
   if(!strcmp(taddr, "*"))
   {
      send_to_server(":%s NOTICE %s :Please include the username.\n", bot.nick, nwho);
      return;
   }
   while(*ptr == '*' || *ptr == '.')
   {
      ptr++;
   }
   cnt = countdots(ptr);
   if(cnt == 0)
   {
      send_to_server(":%s NOTICE %s :Please make the hostname a more specific one.\n", bot.nick, nwho);
      return;
   }
   testmask = add_rnick_addrinfo(who, usrhost);
   if(testmask == 0)
   {
      send_to_server(":%s NOTICE %s :MASK %s added for %s\n", bot.nick, nwho, usrhost, who);
   }
   if(testmask == 1)
   {
      send_to_server(":%s NOTICE %s :MASK %s already covered by existing entry for %s\n", bot.nick, nwho, usrhost, who);

      return;
   }
   write_rnickfile();
}

void del_mask(char *who, char *rest)
{
   struct rnickinfo *rnick;
   struct adderinfo *adder;
   char *usrhost, *nwho;
   int rmv;

   nwho = nick2num(who);
   if(strlen(rest) > 100) return;
   usrhost = strtok(rest, " ");
   if (!is_auth(who))
   {
      send_to_server(":%s NOTICE %s : You need to be AUTH'd with %s first.\n", bot.nick, nwho, bot.nick);
      return;
   }
   rmv = delete_addrnode(who, usrhost);
   if(rmv == 0)
      send_to_server(":%s NOTICE %s :You cannot remove the last MASK\n", bot.nick, nwho, usrhost, who);
   else if(rmv == 1)
   {
      send_to_server(":%s NOTICE %s :MASK %s has been deleted for %s\n", bot.nick, nwho, usrhost, who);
      write_rnickfile();
   }
   else if(rmv == 2)
   {
      send_to_server(":%s NOTICE %s :MASK %s does not exist for %s\n", bot.nick, nwho, usrhost, who);
   }
}

void stat_all(char *who, char *rest)
{
   struct rnickinfo *rnick;
   struct adderinfo *addr;
   char *nwho, *authed, *admin, *kills, *purge, sbuff[10000], buff[10000], *nick, nick1[10000];

   nwho = nick2num(who);
   if (!is_auth(who))
   {
      send_to_server(":%s NOTICE %s : You are not authorized to use that command.\n", bot.nick, nwho);
      return;
   }
            rnick = rnickhead;
            if(rest == NULL)
            while(rnick != NULL)
            {
               if(colorm)
               {
                  if(rnick->authed == 0) authed = "\0034NO\003";
                  else authed = "\0033YES\003";
                  if(rnick->admin == 2) admin = "\0033NS Admin\003";
                  else if(rnick->admin == 1) admin = "\0033NS Helper\003";
                  else if(rnick->admin == 0) admin = "\0033User\003";
                  if(rnick->kills == 0) kills = "\0034NO\003";
                  else kills = "\0033YES\003";
                  if(rnick->purge == 0) purge = "\0034OFF\003";
                  else purge = "\0033ON\003";
                  send_to_server(":%s NOTICE %s : \0031Profile: [\003\00312 %s\003\0031 ] \0031Authed:\003 %s  \0031Level:\003 %s  \0031Kill:\003 %s  \0031NoPurge:\003 %s\n", bot.nick, nwho, rnick->nick, authed, admin, kills, purge);
                  send_to_server(":%s NOTICE %s : \0031LastSeen: \003\0034 %s\003\n", bot.nick, nwho, get_time(rnick->stamp));
               }
               else
               {
                  if(rnick->authed == 0) authed = "NO";
                  else authed = "YES";
                  if(rnick->admin == 2) admin = "NS Admin";
                  else if(rnick->admin == 1) admin = "NS Helper";
                  else if(rnick->admin == 0) admin = "User";
                  if(rnick->kills == 0) kills = "NO";
                  else kills = "YES";
                  if(rnick->purge == 0) purge = "OFF";
                  else purge = "ON";
                  send_to_server(":%s NOTICE %s : Profile: [ %s ] Authed: %s  Level: %s  Kill: %s  NoPurge: %s\n", bot.nick, nwho, rnick->nick, authed, admin, kills, purge);
                  send_to_server(":%s NOTICE %s : LastSeen:  %s\n", bot.nick, nwho, get_time(rnick->stamp));
               }
                  sbuff[0] = '\0';
                  buff[0] = '\0';
                  addr = rnick->adderhead;
                  while(addr != NULL)
                  {
                     sprintf(sbuff, "%s  ", addr->address);
                     strcat(buff, sbuff);
                     addr = addr->next;
                  }
               if(colorm)
               {
                  send_to_server(":%s NOTICE %s : \0031Masks:\003\0032 %s\003\n", bot.nick, nwho, buff);
               }
               else
               {
                  send_to_server(":%s NOTICE %s : Masks: %s\n", bot.nick, nwho, buff);
               }
               send_to_server(":%s NOTICE %s : -\n", bot.nick, nwho);
               rnick = rnick->next;
            }
            if(rest != NULL)
            while(rnick != NULL)
            {
               nick = strtok(rest, " ");
               sprintf(nick1, "*%s*", nick);
               if(!bancmp(nick1, rnick->nick))
               {
               
                  if(colorm)
                  {
                     if(rnick->authed == 0) authed = "\0034NO\003";
                     else authed = "\0033YES\003";
                     if(rnick->admin == 2) admin = "\0033NS Admin\003";
                     else if(rnick->admin == 1) admin = "\0033NS Helper\003";
                     else if(rnick->admin == 0) admin = "\0033User\003";
                     if(rnick->kills == 0) kills = "\0034NO\003";
                     else kills = "\0033YES\003";
                     if(rnick->purge == 0) purge = "\0034OFF\003";
                     else purge = "\0033ON\003";
                     send_to_server(":%s NOTICE %s : \0031Profile: [\003\00312 %s\003\0031 ] \0031Authed:\003 %s  \0031Level:\003 %s  \0031Kill:\003 %s  \0031NoPurge:\003 %s\n", bot.nick, nwho, rnick->nick, authed, admin, kills, purge);
                     send_to_server(":%s NOTICE %s : \0031LastSeen: \003\0034 %s\003\n", bot.nick, nwho, get_time(rnick->stamp));
                  }
                  else
                  {
                     if(rnick->authed == 0) authed = "NO";
                     else authed = "YES";
                     if(rnick->admin == 2) admin = "NS Admin";
                     else if(rnick->admin == 1) admin = "NS Helper";
                     else if(rnick->admin == 0) admin = "User";
                     if(rnick->kills == 0) kills = "NO";
                     else kills = "YES";
                     if(rnick->purge == 0) purge = "OFF";
                     else purge = "ON";
                     send_to_server(":%s NOTICE %s : Profile: [ %s ] Authed: %s  Level: %s  Kill: %s  NoPurge: %s\n", bot.nick, nwho, rnick->nick, authed, admin, kills, purge);
                     send_to_server(":%s NOTICE %s : LastSeen:  %s\n", bot.nick, nwho, get_time(rnick->stamp));
                  }
                  sbuff[0] = '\0';
                  buff[0] = '\0';
                  addr = rnick->adderhead;
                  while(addr != NULL)
                  {
                     sprintf(sbuff, "%s  ", addr->address);
                     strcat(buff, sbuff);
                     addr = addr->next;
                  }
                  if(colorm)
                  {
                     send_to_server(":%s NOTICE %s : \0031Masks:\003\0032 %s\003\n", bot.nick, nwho, buff);
                  }
                  else
                  {
                     send_to_server(":%s NOTICE %s : Masks: %s\n", bot.nick, nwho, buff);
                  }
                  send_to_server(":%s NOTICE %s : -\n", bot.nick, nwho);
               }
               rnick = rnick->next;
            }
}

void stat_it(char *who, char *rest)
{
   struct rnickinfo *rnick;
   struct adderinfo *addr;
   char *nwho, *authed, *admin, *kills, sbuff[10000], buff[10000];

   nwho = nick2num(who);
   if (!is_auth(who))
   {
      send_to_server(":%s NOTICE %s : You are not authorized to use that command.\n", bot.nick, nwho);
      return;
   }
            rnick = rnickhead;
            while(rnick != NULL)
            {
               if(!strcasecmp(rnick->nick, who))
               {
                  if(colorm)
                  {
                     if(rnick->authed == 0) authed = "\0034NO\003";
                     else authed = "\0033YES\003";
                     if(rnick->admin == 2) admin = "\0033NS Admin\003";
                     else if(rnick->admin == 1) admin = "\0033NS Helper\003";
                     else if(rnick->admin == 0) admin = "\0033User\003";
                     if(rnick->kills == 0) kills = "\0034NO\003";
                     else kills = "\0033YES\003";
                     send_to_server(":%s NOTICE %s : \0031Profile: [\003\00312 %s\003\0031 ] \0031Authed:\003 %s  \0031Level:\003 %s  \0031Kill:\003 %s\n", bot.nick, nwho, rnick->nick, authed, admin, kills);
                     send_to_server(":%s NOTICE %s : \0031LastSeen: \003\0034 %s\003\n", bot.nick, nwho, get_time(rnick->stamp));
                  }
                  else
                  {
                     if(rnick->authed == 0) authed = "NO";
                     else authed = "YES";
                     if(rnick->admin == 2) admin = "NS Admin";
                     else if(rnick->admin == 1) admin = "NS Helper";
                     else if(rnick->admin == 0) admin = "User";
                     if(rnick->kills == 0) kills = "NO";
                     else kills = "YES";
                     send_to_server(":%s NOTICE %s : Profile: [ %s ] Authed: %s  Level: %s  Kill: %s\n", bot.nick, nwho, rnick->nick, authed, admin, kills);
                     send_to_server(":%s NOTICE %s : LastSeen:  %s\n", bot.nick, nwho, get_time(rnick->stamp));
                  }
                  sbuff[0] = '\0';
                  buff[0] = '\0';
                  addr = rnick->adderhead;
                  while(addr != NULL)
                  {
                     sprintf(sbuff, "%s  ", addr->address);
                     strcat(buff, sbuff);
                     addr = addr->next;
                  }
                  if(colorm)
                  {
                     send_to_server(":%s NOTICE %s : \0031Masks:\003\0032 %s\003\n", bot.nick, nwho, buff);
                  }
                  else
                  {
                     send_to_server(":%s NOTICE %s : Masks: %s\n", bot.nick, nwho, buff);
                  }
                  send_to_server(":%s NOTICE %s : -\n", bot.nick, nwho);
               }
               rnick = rnick->next;
            }
}

void aset_kill(char *who, char *rest)
{
   struct rnickinfo *rnick;
   char *nwho, *what, *nick;

   nwho = nick2num(who);
   if (!is_auth(who))
   {
      send_to_server(":%s NOTICE %s : You are not authorized to use that command.\n", bot.nick, nwho);
      return;
   }
   if(strlen(rest) > 100) return;
   nick = strtok(rest, " ");
   rnick = rnickhead;
   while(rnick != NULL)
   {
      if(!strcasecmp(nick, rnick->nick))
      {
         if(rnick->kills)
         {
            rnick->kills = 0;
            what = "OFF";
         }
         else
         {
            rnick->kills = 1;
            what = "ON";
         }
         send_to_server(":%s NOTICE %s :Kill has been set to %s for %s \n", bot.nick, nwho, what, nick);
         write_rnickfile();
         return;
      }
       rnick = rnick->next;
   }
}

void set_kill(char *who, char *rest)
{
   struct rnickinfo *rnick;
   char *nwho, *what;

   nwho = nick2num(who);
   if (!is_auth(who))
   {
      send_to_server(":%s NOTICE %s : You are not authorized to use that command.\n", bot.nick, nwho);
      return;
   }
   
   rnick = rnickhead;
   while(rnick != NULL)
   {
      if(!strcasecmp(who, rnick->nick))
      {
         if(rnick->kills)
         {
            rnick->kills = 0;
            what = "OFF";
         }
         else
         {
            rnick->kills = 1;
            what = "ON";
         }
         send_to_server(":%s NOTICE %s :Kill has been set to %s for %s \n", bot.nick, nwho, what, who);
         write_rnickfile();
         return;
      }
       rnick = rnick->next;
   }
}

void admin_level(char *who, char *rest)
{
   struct rnickinfo *rnick;
   char *nick;
   char *nwho, *level;

   nwho = nick2num(who);
   if(strlen(rest) > 100) return;

   if (!is_auth(who))
   {
      send_to_server(":%s NOTICE %s : You are not authorized to use that command.\n", bot.nick, nwho);
      return;
   }
   nick = strtok(rest, " ");
   level = strtok(NULL, " ");
   if (level == NULL)
   {
      send_to_server(":%s NOTICE %s : Must include a level of 0, 1 or 2.\n", bot.nick, nwho);
      return;
   }
   if(!is_num(level) || atoi(level) > 2)
   {
      send_to_server(":%s NOTICE %s : Level must be a value of 0, 1 or 2.\n", bot.nick, nwho);
      return;
   }
   rnick = rnickhead;
   while(rnick != NULL)
   {
      if(!strcasecmp(nick, rnick->nick))
      {
         rnick->admin = atoi(level);
         send_to_server(":%s NOTICE %s : Level for %s is %s\n", bot.nick, nwho, rnick->nick, level);
         write_rnickfile();
         return;
      }
      rnick = rnick->next;
   }
}

void admin_reg(char *who, char *rest)
{
   struct rnickinfo *rnick;
   char *nick, *usrhost, *pass, taddr[100], *ptr;
   char *nwho, *cryptpass;

   nwho = nick2num(who);
   if(strlen(rest) > 100) return;

   if (!is_auth(who))
   {
      send_to_server(":%s NOTICE %s : You are not authorized to use that command.\n", bot.nick, nwho);
      return;
   }
   nick = strtok(rest, " ");
   if(badnick(nick) == -1)
   {
      send_to_server(":%s NOTICE %s : You cannot register an illegal nick.\n", bot.nick, nwho);
      return;
   }  
   rnick = rnickhead;
   while(rnick != NULL)
   {
      if(!strcasecmp(nick, rnick->nick))
      {
          send_to_server(":%s NOTICE %s : %s is currently a registered nick\n", bot.nick, nwho, nick);
          return;
      }
      rnick = rnick->next;
   }
   usrhost = strtok(NULL, " ");
   if(usrhost == NULL)
   {
      send_to_server(":%s NOTICE %s : You need to review the help for ADMINPASS\n", bot.nick, nwho);
      return;
   }
   if(strchr(usrhost, '!'))
   {
      send_to_server(":%s NOTICE %s :Incorrect syntax! Format is user@hostmask\n", bot.nick, nwho);
      return;
   }
   if(!strchr(usrhost, '@'))
   {
      send_to_server(":%s NOTICE %s :Incorrect syntax! Format is user@hostmask\n", bot.nick, nwho);
      return;
   }
   strcpy(taddr, usrhost);
   if(ptr = strchr(taddr, '@')) *ptr++ = '\0';
   if(!strcmp(taddr, "*"))
   {
      send_to_server(":%s NOTICE %s :Please include the username.\n", bot.nick, nwho);
      return;
   }
   if(!strcmp(ptr, "*") || !strcmp(ptr, "*.*") || !strcmp(ptr, "*.*.*"))
   {
      send_to_server(":%s NOTICE %s :Please make the hostname a more specific one.\n", bot.nick, nwho);
      return;
   }
   pass = strtok(NULL, " ");
   if(pass == NULL)
   {
      send_to_server(":%s NOTICE %s : You need to review the help for ADMINREG\n", bot.nick, nwho);
      return;
   }
   if(strlen(pass) > 8)
   {
       send_to_server(":%s NOTICE %s :Password can only be 8 characters\n", bot.nick, nwho);
       send_to_server(":%s NOTICE %s :Password NOT Changed\n", bot.nick, nwho);
       return;
   }
   cryptpass = mkpass(pass, "0");
   add_rnickinfo(nick, cryptpass, time(NULL), FALSE, FALSE, FALSE);
   add_rnick_addrinfo(nick, usrhost);
   send_to_server(":%s NOTICE %s : You have registered Nick %s Hostmask %s Password %s\n", bot.nick, nwho, nick, usrhost, pass);
   write_rnickfile();
}

void admin_newpass(char *who, char *rest)
{
   struct rnickinfo *rnick;
   char *nick, *pass;
   char *nwho, *cryptpass;

   nwho = nick2num(who);
   if(strlen(rest) > 100) return;

   if (!is_auth(who))
   {
      send_to_server(":%s NOTICE %s : You are not authorized to use that command.\n", bot.nick, nwho);
      return;
   }
   nick = strtok(rest, " ");
   pass = strtok(NULL, " ");
   if(pass == NULL)
   {
      send_to_server(":%s NOTICE %s : You need to review the help for ADMINPASS\n", bot.nick, nwho);
      return;
   }
   if(strlen(pass) > 8)
   {
       send_to_server(":%s NOTICE %s :Password can only be 8 characters\n", bot.nick, nwho);
       send_to_server(":%s NOTICE %s :Password NOT Changed\n", bot.nick, nwho);
       return;
   }
   rnick = rnickhead;
   while(rnick != NULL)
   {
      if(!strcasecmp(nick, rnick->nick))
      {
         cryptpass = mkpass(pass, "0");
         strcpy(rnick->pass, cryptpass);
         send_to_server(":%s NOTICE %s : Password changed for %s to %s \n", bot.nick, nwho, rnick->nick, pass);
         write_rnickfile();
         return;
      }
      rnick = rnick->next;
   }
   send_to_server(":%s NOTICE %s : That nick is not registered\n", bot.nick, nwho);
}

void set_nopurge(char *who, char *rest)
{
   struct rnickinfo *rnick;
   char *nick, *nwho, *what;

   if(strlen(rest) > 100) return;
   nwho = nick2num(who);
   if (!is_auth(who))
   {
      send_to_server(":%s NOTICE %s : You are not authorized to use that command.\n", bot.nick, nwho);
      return;
   }
   nick = strtok(rest, " ");
   rnick = rnickhead;
   while(rnick != NULL)
   {
      if(!strcasecmp(nick, rnick->nick))
      {
         if(rnick->purge)
         {
            rnick->purge = 0;
            what = "OFF";
         }
         else
         {
            rnick->purge = 1;
            what = "ON";
         }
         send_to_server(":%s NOTICE %s :NoPurge has been set to %s for %s \n", bot.nick, nwho, what, nick);
         write_rnickfile();
         return;
      }
      rnick = rnick->next;
   }
}
void listbad(char *who, char *rest)
{
   struct badinfo *bad;
   char *nwho;

   nwho = nick2num(who);
   if (!is_auth(who))
   {
      send_to_server(":%s NOTICE %s : You are not authorized to use that command.\n", bot.nick, nwho);
      return;
   }
   send_to_server(":%s NOTICE %s :Bad Nick List:\n", bot.nick, nwho);
   bad = badhead;
   while(bad != NULL)
   {
      send_to_server(":%s NOTICE %s :    %s\n", bot.nick, nwho, bad->nick);
      bad = bad->next;
   }
}

void admin_add_mask(char *who, char *rest)
{
   struct rnickinfo *rnick;
   struct adderinfo *adder;
   char *usrhost, *nwho, taddr[1000], *ptr, *nick;
   int testmask = 0;

   nwho = nick2num(who);
   if (!is_auth(who))
   {
      send_to_server(":%s NOTICE %s : You need to be AUTH'd with %s first.\n", bot.nick, nwho, bot.nick);
      return;
   }
   if(strlen(rest) > 100) return;
   nick = strtok(rest, " ");
   usrhost = strtok(NULL, " ");
   if(usrhost == NULL )
   {
      send_to_server(":%s NOTICE %s :You did not include a mask - user@hostmask\n", bot.nick, nwho);
      return;
   }
   if(strchr(usrhost, '!'))
   {
      send_to_server(":%s NOTICE %s :Incorrect syntax! Format is user@hostmask\n", bot.nick, nwho);
      return;
   }
   if(!strchr(usrhost, '@'))
   {
      send_to_server(":%s NOTICE %s :Incorrect syntax! Format is user@hostmask\n", bot.nick, nwho);
      return;
   }
   strcpy(taddr, usrhost);
   if(ptr = strchr(taddr, '@')) *ptr++ = '\0';
   if(!strcmp(taddr, "*"))
   {
      send_to_server(":%s NOTICE %s :Please include the username.\n", bot.nick, nwho);
      return;
   }
   if(!is_anchar(ptr))
   {
      send_to_server(":%s NOTICE %s :Please make the hostname a more specific one.\n", bot.nick, nwho);
      return;
   }
   testmask = add_rnick_addrinfo(nick, usrhost);
   if(testmask == 0)
   {
      send_to_server(":%s NOTICE %s :MASK %s added for %s\n", bot.nick, nwho, usrhost, nick);
   }
   if(testmask == 1)
   {
      send_to_server(":%s NOTICE %s :MASK %s already covered by existing entry for %s\n", bot.nick, nwho, usrhost, nick);

      return;
   }
   write_rnickfile();
}

void admin_del_mask(char *who, char *rest)
{
   struct rnickinfo *rnick;
   struct adderinfo *adder;
   char *usrhost, *nwho, *nick;

   nwho = nick2num(who);
   if (!is_auth(who))
   {
      send_to_server(":%s NOTICE %s : You need to be AUTH'd with %s first.\n", bot.nick, nwho, bot.nick);
      return;
   }
   if(strlen(rest) > 100) return;
   nick = strtok(rest, " ");
   usrhost = strtok(NULL, " ");
   if(usrhost == NULL )
   {
      send_to_server(":%s NOTICE %s :You did not include a mask - user@hostmask\n", bot.nick, nwho);
      return;
   }
   if(delete_addrnode(nick, usrhost) == 0)
      send_to_server(":%s NOTICE %s :You cannot remove the last MASK\n", bot.nick, nwho);
   else
   {
      send_to_server(":%s NOTICE %s :MASK %s has been deleted for %s\n", bot.nick, nwho, usrhost, nick);
      write_rnickfile();
   }
}
