/* NS1 - Nick Services ns-src/add_info.c
 * NS1.2 Copyright  1998-2000 Chris Birch(IRCore)
 */

#include<bot.h>

void add_burst(char *channel, long chanstamp)
{
   struct burstinfo *new, *current;
   new = (struct burstinfo *) calloc(1, sizeof(struct burstinfo));
   if(new != NULL)
   {
      new->next = NULL;
      strcpy(new->channel, channel);
      new->chanstamp = chanstamp;
      if(bursthead == NULL) bursthead = new;
      else
      {
         current = bursthead;
         while(current->next != NULL) current = current->next;
         current->next = new;
      }
   }
   else log(ERRLOG_FILE, "[%s] Adding Burst: Out of memory\n", date());
}

void add_badinfo(char *chan)
{
   struct badinfo *new, *current;

   new = (struct badinfo *) calloc(1, sizeof(struct badinfo));
   if(new != NULL)
   {
       new->next = NULL;
       strcpy(new->nick, chan);
       if(badhead == NULL) badhead = new;
       else
       {
          current = badhead;
          while(current->next != NULL) current = current->next;
          current->next = new;
       }
   }
   else
   {
      log(ERRLOG_FILE, "[%s] Adding new bad: Out of memory\n", date());
      return;
   }
}

void add_templist(char *nick, char *numeric)
{
   struct templist *new, *current;
   new = (struct templist *) calloc(1, sizeof(struct templist));
   if(new != NULL)
   {
      new->next = NULL;
      if(nick != NULL)
         strcpy(new->nick, nick);
      if(numeric != NULL)
         strcpy(new->numeric, numeric);
      if(listhead == NULL) listhead = new;
      else
      {
         current = listhead;
         while(current->next != NULL) current = current->next;
         current->next = new;
      }
   }
   else log(ERRLOG_FILE, "[%s] Adding templist: Out of memory\n", date());
}

void add_nickinfo(char *nick, char *user, char *host, char *base64, char *num, char *server, char *reason)
{
   struct nickinfo *new, *current;
   new = (struct nickinfo *) calloc(1, sizeof(struct nickinfo));
   if(new != NULL) 
   {
      new->next = NULL;
      strcpy(new->nick, nick);
      strcpy(new->user, user);
      strcpy(new->base64, base64);
      strcpy(new->host, host);
      strcpy(new->numeric, num);
      strcpy(new->server, server);

/* reason should contain modes if NS joined/rejoined */
      if (reason[0] == '+') {
	 /* modes given across; check for next mode char */
	 if (reason[1] == 'o') new->is_oper = TRUE;
	 else new->is_oper = FALSE;
      }
      if(nickhead == NULL) nickhead = new;
      else 
      {
         current = nickhead;
         while(current->next != NULL) current = current->next;
         current->next = new;
      }
   }
   else log(ERRLOG_FILE, "[%s] Adding new nick: Out of memory\n", date());
}

void add_killinfo(char *nick, char *numeric, long timestamp)
{
   struct killinfo *new, *current;
   new = (struct killinfo *) calloc(1, sizeof(struct killinfo));

   if(new != NULL)
   {
      new->next = NULL;
      strcpy(new->nick, nick);
      strcpy(new->numeric, numeric);
      new->timestamp = timestamp;
      if(killhead == NULL) killhead = new;
      else
      {
         current = killhead;
         while(current->next != NULL) current = current->next;
         current->next = new;
      }
   }
   else log(ERRLOG_FILE, "[%s] Adding Kill Info: Out of memory\n", date());
}

void add_rnickinfo(char *nick, char *pass, long stamp, int admin, int kills, int purge)
{
   struct rnickinfo *new, *current;
   new = (struct rnickinfo *) calloc(1, sizeof(struct rnickinfo));

   if(new != NULL)
   {
      new->next = NULL;
      strcpy(new->nick, nick);
      strcpy(new->pass, pass);
      new->stamp = stamp;
      new->admin = admin;
      new->kills = kills;
      new->purge = purge;
      new->adderhead = NULL;
      if(rnickhead == NULL) rnickhead = new;
      else
      {
         current = rnickhead;
         while(current->next != NULL) current = current->next;
         current->next = new;
      }
   }
   else log(ERRLOG_FILE, "[%s] Adding Reserved Nick: Out of memory\n", date());
}

int add_rnick_addrinfo(char *nick, char *address)
{
   struct rnickinfo *rnick, *rnicktest;
   struct adderinfo *new, *current, *addrtest;
   char raddr[100];
   int got_one = 0;

   raddr[0] = '\0';
         rnicktest = rnickhead;
         while(rnicktest != NULL)
         {
            if(!strcasecmp(nick, rnicktest->nick))
            {
               addrtest = rnicktest->adderhead;
               while(addrtest != NULL)
               {
                  if(!strcasecmp(address, addrtest->address)) return 1;
                  collapse(address);
                  if(!bancmp(address, addrtest->address) || !bancmp(addrtest->address, address))
                  {
                     if(strlen(address) < strlen(addrtest->address))
                     {
                        strcpy(raddr, addrtest->address);
                        got_one = 1;
                     }
                     else return 1;
                  }
                  addrtest = addrtest->next;
               }
            }
            rnicktest = rnicktest->next;
         }
   if(got_one)
      delete_addrnode(nick, raddr);
   got_one = 0;
         rnick = rnickhead;
         while(rnick != NULL)
         {
            if(!strcasecmp(nick, rnick->nick))
            {
               new = (struct adderinfo *) calloc(1, sizeof(struct adderinfo));
               if(new != NULL)
               {
                  new->next = NULL;
                  strcpy(new->address, address);
                  if(rnick->adderhead == NULL) rnick->adderhead = new;
                  else
                  {
                     current = rnick->adderhead;
                     while(current->next != NULL) current = current->next;
                     current->next = new;
                  }
               }
               else log(ERRLOG_FILE, "[%s] Adding Addr: Out of memory\n", date());
            }
            rnick = rnick->next;
         }
   return 0;
}
