/* NS1 - Nick Services ns-src/char_tools.c
 * NS1.2 Copyright  1998-2000 Chris Birch(IRCore)
 */

#include<bot.h>

void strip_chars(char *buff)
{
   char *ptr;
   if(ptr = strchr(buff, '+')) ptr++;
   else if(ptr = strchr(buff, '-')) ptr++;
}


void log(char *filename, char *format, ...)
{
   va_list arglist;
   FILE *fp;
   if(!logging) return;
   if((fp = fopen(filename, "a")) == NULL)
   {
      file_error(filename);
      return;
   }
   va_start(arglist, format);
   vfprintf(fp, format, arglist);
   va_end(arglist);
   fclose(fp);
}

void strip_newline(char *string)
{
   char *ptr;
   if(ptr = strchr(string, '\n')) *ptr = '\0';
   if(ptr = strchr(string, '\r')) *ptr = '\0';
}

char strlwr(char *buf)
{
   int i = 0;
   while(buf[i] != '\0')
   {
      buf[i] = tolower(buf[i]);
      i++;
   }
   buf[i] = '\0';
}

char *strupr(char *buf)
{
   int i = 0;
   char tbuff, nbuff;
   while(buf[i] != '\0')
   {
      if(islower(buf[i]))
      {
          tbuff = toupper(buf[i]);
          strbuff[i++] = tbuff;
      }
      else if(isspace(buf[i]))
          strbuff[i++] = ' ';
      else
      {
         nbuff = buf[i-1];
         strbuff[i++] = nbuff;
      }
   }
   strbuff[i] = '\0';
   return(strbuff);
}

void strip_period(char *txt)
{
   char buff[100];
   int i = 0, j = 0;
   while(txt[i] != '\0')
   {
      buff[j++] = txt[i];
      if(txt[i] == '*' && txt[i+1] == '.') i+=2;
      else i++;
   }
   buff[j] = '\0';
   strcpy(txt, buff);
}

void strip_slash(char *ptr)
{
   while(*ptr && *ptr++ != ' ') if(*ptr == '/') *ptr = '\\';
}

void strip_bslash(char *text)
{
   char *ptr;
   while(ptr = strchr(text, '\\')) *ptr = '/';
}

void trailing_blanks(char *str)
{
   int i;
   for(i = strlen(str); i > 0; i--)
   {
      if(isspace(str[i-1])) str[i-1] = '\0';
      else return;
   }
}

void del_wild(char *txt)
{
   char buff[100];
   int i = 0, j = 0;
   while(txt[i] != '\0')
   {
      if(txt[i] != '*' && txt[i] != '?') buff[j++] = txt[i];
      i++;
   }
   buff[j] = '\0';
   strcpy(txt, buff);
   strip_period(txt);
}

int is_anchar(char *num)
{

   while(*num)
   {
      if(isalnum(*num)) return 1;
      num++;
   }
   return 0;
}
