/* NS1 - Nick Services ns-src/files.c
 * NS1.2 Copyright  1998-2000 Chris Birch(IRCore)
 */

#include<bot.h>

void write_badnick()
{
   FILE *fp;
   struct badinfo *bad;

   if((fp = fopen(BNICKLIST, "w")) == NULL)
   {
      file_error(BNICKLIST);
      return;
   }
   bad = badhead;
   if(bad == NULL)
   {
      fclose(fp);
      return;
   }
   while(bad != NULL)
   {
     fprintf(fp, "%s\n", bad->nick);
     bad = bad->next;
   }
   fclose(fp);
}

void load_badnick()
{
   FILE *fp;
   struct badinfo *new, *current;
   char buff[300], *chan;

   if((fp = fopen(BNICKLIST, "r")) == NULL)
   {
      file_error(BNICKLIST);
      return;
   }
   while(fgets(buff, 10000, fp) != NULL)
   {
      strip_newline(buff);
      new = (struct badinfo *) calloc(1, sizeof(struct badinfo));
      if(new != NULL)
      {
         new->next = NULL;
         strcpy(new->nick, buff);
         if(badhead == NULL) badhead = new;
         else
         {
            current = badhead;
            while(current->next != NULL) current = current->next;
            current->next = new;
         }
      }
      else log(ERRLOG_FILE, "[%s] Adding new Bad Nick: Out of memory\n", date());
   }
   fclose(fp);
}

void load_rnicklist()
{
   FILE *fp;
   char buff[10000], *nick, *uhost, *pass, *stamp, *admin, *kills, *purge;
   if((fp = fopen(RNICKLIST, "r")) == NULL) 
   {
      file_error(RNICKLIST);
      return;
   }
   while(fgets(buff, 10000, fp) != NULL) 
   {
      strip_newline(buff);
      nick = strtok(buff, " ");
      pass = strtok(NULL, " ");
      stamp = strtok(NULL, " ");
      admin = strtok(NULL, " ");
      kills = strtok(NULL, " ");
      purge = strtok(NULL, " ");
      add_rnickinfo(nick, pass, atol(stamp), atoi(admin), atoi(kills), atoi(purge));
      while((uhost = strtok(NULL, " ")) != NULL)
      {
         add_rnick_addrinfo(nick, uhost);
      }
   }
   fclose(fp);
}

void write_rnickfile()
{
   FILE *fp;
   struct rnickinfo *nick;
   struct adderinfo *addr;
   char tmp[10000], tmp1[10000], tmp2[10000];
   int first_time = 0;

   if((fp = fopen(RNICKLIST, "w")) == NULL) 
   {
      file_error(RNICKLIST);
      return;
   }
   nick = rnickhead;
   if(nick == NULL)
   {
      fclose(fp);
      return;
   }
   while(nick != NULL) 
   {
      tmp1[0] = '\0';
      tmp2[0] = '\0';
      sprintf(tmp, "%s %s %lu %d %d %d", nick->nick, nick->pass, nick->stamp, nick->admin, nick->kills, nick->purge);
      addr = nick->adderhead;
      first_time == 0;
      while(addr != NULL)
      {
         if(!first_time)
         {
            strcpy(tmp1, addr->address);
            first_time=1;
         }
         else
         {
            sprintf(tmp2, "%s %s", tmp1, addr->address);
            strcpy(tmp1, tmp2);
         }
         addr = addr->next;
      }
      fprintf(fp, "%s %s\n", tmp, tmp1);
      nick = nick->next;
   }
   fclose(fp);
}

void reload_rnicklist(char *who, char *rest)
{
   char *nwho;
   nwho = nick2num(who);
   free_rnickinfo();
   load_rnicklist();
   send_to_server(":%s NOTICE %s :NICKSERV NickList has been reloaded.\n", bot.nick, nwho);
}

void free_rnicklist()
{
   struct rnickinfo *current, *tmp;
   log(ERRLOG_FILE, "[%s] Freeing NickServ List\n", date());
   current = rnickhead;
   while(current != NULL)
   {
      if(current == rnickhead) rnickhead = rnickhead->next;
      tmp = current->next;
      free(current);
      current=tmp;
   }
}

void free_templist()
{
   struct templist *current, *tmp;
   log(ERRLOG_FILE, "[%s] Freeing templist\n", date());
   current = listhead;
   while(current != NULL)
   {
      if(current == listhead) listhead = listhead->next;
      tmp = current->next;
      free(current);
      current=tmp;
   }
}

void write_comm_list()
{
   FILE *fp;
   int i = 0;
   if((fp = fopen(COM_FILE, "w")) == NULL)
   {
      file_error(COM_FILE);
      return;
   }
   fprintf(fp, "%s\n", "***************************************");
   fprintf(fp, "%s\n", "*   DO NOT Modify this File By Hand   *");
   fprintf(fp, "%s\n", "***************************************");
   for(i = 0; *commands[i].name; i++)
   {
      if(!strcmp(commands[i].realname, " "))
      {
         fclose(fp);
         return;
      }
      fprintf(fp, "%-15s %-15s %-5d %d\n", commands[i].name, commands[i].realname, commands[i].level, commands[i].disable);
   }
   fclose(fp);
}

void write_all_files()
{
   if(joined)
   {
      write_comm_list();
      write_rnickfile();
      send_to_server(":%s WALLOPS :Wrote Out ALL Bot Files\n", myserver);
   }
}
