/* NS1 - Nick Services ns-src/load_cfg.c
 * NS1.2 Copyright  1998-2000 Chris Birch(IRCore)
 */

#include<bot.h>

void load_cfg()
{
   FILE *fp;
   char buffer[MAXDEF], *field = NULL;

   ymsgchan = 0;
   buffer[0]='\0';
   if((fp = fopen(CFG_FILE, "r")) == NULL) 
   {
      file_error(CFG_FILE);
      return;
   }
   while(fgets(buffer, MAXDEF, fp)) 
   {
      if(buffer[0] == '*' || buffer[0] == '\n') continue;
      strip_newline(buffer);
      trailing_blanks(buffer);
      if(field = strchr(buffer, ' ')) *field++ = '\0';
      if(!strcmp(buffer, "DEFAULT_SERVER")) 
      {
         strcpy(bot.server, field);
      }
      if(!strcmp(buffer, "DEFAULT_PORT")) 
      {
         bot.port = atoi(field);
      }
      if(!strcmp(buffer, "SERVERS"))
      {
         while(fgets(buffer, MAXDEF, fp)[0] != '-')
         {
            if(buffer[0] == '*') continue;
            strcpy(servers[no_servers].name, strtok(buffer, " \n"));
            servers[no_servers].port = atoi(strtok(NULL, " \n"));
            no_servers++;
         }
      }
      if(!strcmp(buffer, "ACCESS_DENIED")) 
      {
         strcpy(denied_msg, field);
      }
      if(!strcmp(buffer, "FLOOD_RATE")) 
      {
         flood_rate = atoi(field);
      }
      if(!strcmp(buffer, "FLOOD_TIME")) 
      {
         flood_time = atoi(field);
      }
      if(!strcmp(buffer, "RESET_TIME")) 
      {
         reset_time = atoi(field);
      }
      if(!strcmp(buffer, "MSG_CHAN") && field != NULL && *field == '#')
      {
         ymsgchan = 1;
         strcpy(msg_chan, field);
      }
      if(!strcmp(buffer, "NETPASS")) 
      {
         strcpy(netpass, field);
      }
      if(!strcmp(buffer, "MYSERVER")) 
      {
         strcpy(myserver, field);
      }
      if(!strcmp(buffer, "OPERSERV_HOST"))
      {
         strcpy(uworldhost, field);
      }
      if(!strcmp(buffer, "OPERSERV_NICK"))
      {
         strcpy(uworldnick, field);
      }
      if(!strcmp(buffer, "CHANSERV_HOST"))
      {
         strcpy(chanhost, field);
      }
      if(!strcmp(buffer, "CHANSERV_NICK"))
      {
         strcpy(chanserv, field);
      }
      if(!strcmp(buffer, "MYMODES")) 
      {
         strcpy(mymodes, field);
      }
      if(!strcmp(buffer, "REASON")) 
      {
         strcpy(reason, field);
      }
      if(!strcmp(buffer, "IRCNAME")) 
      {
         strcpy(ircname, field);
      }
      if(!strcmp(buffer, "IRCUSER")) 
      {
         strcpy(ircuser, field);
      }
      if(!strcmp(buffer, "MYHOST")) 
      {
         strcpy(myhost, field);
      }
      if(!strcmp(buffer, "MAXUSERLEVEL"))
      {
         maxuserlevel=atoi(field);
      }
      if(!strcmp(buffer, "MAXADMNLEVEL"))
      {
         maxadmnlevel=atoi(field);
      }
      if(!strcmp(buffer, "BOTNICK")) 
      {
         strcpy(botnick, field);
      }
      if(!strcmp(buffer, "PID_FILE")) 
      {
         strcpy(pid_file, field);
      }
      if(!strcmp(buffer, "PURGE_TIME")) 
      {
         purge_time = atol(field);
      }
      if(!strcmp(buffer, "QUIT_MSG")) 
      {
         strcpy(quit_msg, field);
      }
      if(!strcmp(buffer, "SERVER_NUM"))
      {
         server_num=atoi(field);
      }
      if(!strcmp(buffer, "LOGGING"))
      {
         logging=atoi(field);
      }
      if(!strcmp(buffer, "MAXRNICKS"))
      {
         maxrnicks=atoi(field);
      }
      if(!strcmp(buffer, "COLOR"))
      {
         colorm=atoi(field);
      }
      if(!strcmp(buffer, "KILLFLOOD"))
      {
         killflood=atoi(field);
      }
      if(!strcmp(buffer, "PRIVMSG"))
      {
         y_privmsg=atoi(field);
      }
  }
   fclose(fp);
}
