/* NS1 - Nick Services ns-src/misc_tools.c
 * NS1.2 Copyright  1998-2000 Chris Birch(IRCore)
 */

#include<bot.h>

int badnick(char *nick)
{
   struct badinfo *bad;
   char buff[100], *host, *nwho;

   bad = badhead;
   while(bad != NULL)
   {
      if(strstr(nick,bad->nick))
      {
          return -1;
      }
      bad=bad->next;
   }
   return 0;
}

void debug(char *format, ...)
{
#ifdef DEBUG
   char buff[5000];
   va_list arglist;
   
   buff[0] = '\0';
   va_start(arglist, format);
   vsprintf(buff, format, arglist);
   if(ymsgchan)
     send_to_server(":%s PRIVMSG %s :%s\n", bot.nick, msg_chan, buff);
   va_end(arglist);
#endif
}

char *date()
{
   time_t timer;
   time(&timer);
   strcpy(strbuff, ctime(&timer));
   strip_newline(strbuff);
   return strbuff;
}

char *bottime()
{
   time_t timer;
   struct tm *ntime;

   time(&timer);
   ntime=localtime(&timer);
   sprintf(strbuff, "%02d:%02d:%02d",ntime->tm_hour,ntime->tm_min,ntime->tm_sec);
   return (strbuff);
}

void command_log(char *who, char *cmd, char *rest)
{
   char nmsg[10], nrest[5000], *chan = NULL;

   nrest[0]='\0';nmsg[0]='\0';
   if(strcmp(cmd, "PRIVMSG") && joined == TRUE)
   {
      if(rest == NULL) 
      {
         log(LOG_FILE, "[%s] %s %s\n", date(), who, cmd);
         if(ymsgchan)
           send_to_server(":%s PRIVMSG %s : [%s] %s by %s\n", botnick, msg_chan, bottime(), cmd, who);
      }
      else 
      {
         if(!strcasecmp(cmd, "AUTH") || !strcasecmp(cmd, "ADMINPASS") || !strcasecmp(cmd, "NEWPASS") || !strcasecmp(cmd, "REGISTER") || !strcasecmp(cmd, "RECOVER") || !strcasecmp(cmd, "ADDTHISMASK") || !strcasecmp(cmd, "ADMINREG"))
         {
            strcpy(nmsg, "*******");
            rest=nmsg;
         }
         log(LOG_FILE, "[%s] %s %s %s\n", date(), who, cmd, rest);
         if(ymsgchan)
           send_to_server(":%s PRIVMSG %s : [%s] %s %s by %s\n", botnick, msg_chan, bottime(), cmd, rest, who);
      }
   }
}

int send_to_server(char *format, ...)
{
   va_list arglist;
   char buffer[MAXBUF], who[MAXBUF], *cmd, *rest, newformat[MAXBUF];

   buffer[0]='\0';
   va_start(arglist, format);
   vsprintf(buffer, format, arglist);
   va_end(arglist);
   strcpy(who, buffer);
   if(cmd = strchr(who, ' ')) *cmd++ = '\0';
   if(rest = strchr(cmd, ' ')) *rest++ = '\0';
   if(y_privmsg && !strcasecmp(cmd, "NOTICE") && !strstr(rest, "PING") && !strstr(rest, "VERSION"))
   {
      sprintf(buffer, "%s PRIVMSG %s", who, rest);
      return(writeln(buffer));
   }
   return(writeln(buffer));
}

void send_denied_msg(char *nick)
{
   char *nwho = NULL;

   nwho = nick2num(nick);
   send_to_server(":%s NOTICE %s :%s\n", bot.nick, nwho, denied_msg);
}

char *get_command_name(char *rcommand)
{
   int i = 0;

   for(i = 0; *commands[i].name; i++)
   {
      if(!strcasecmp(rcommand, commands[i].realname)) return commands[i].name;
   }
   return;
}

char *get_command_rname(char *command)
{
   int i = 0;

   for(i = 0; *commands[i].name; i++)
   {
      if(!strcasecmp(command, commands[i].name)) return commands[i].realname;
   }
   return;
}

int get_command_level(char *command)
{
   int i = 0;

   for(i = 0; *commands[i].name; i++)
   {
      if(!strcasecmp(command, commands[i].realname)) return commands[i].level;
   }
   return -1;
}

void file_error(char *fname)
{
   fprintf(stderr, "Error opening %s\n", fname);
  log(ERRLOG_FILE, "[%s] Error opening %s\n", date(), fname);
}

char *get_time(long ttime)
{
  char tmp[200];
  struct tm *tmptr;
  int isdst=0, gmtoffset = 0;

  newtime[0] = '\0';tmp[0] = '\0';
  tmptr=localtime((time_t *)&ttime);
  strcpy(tmp,ctime((time_t *)&ttime));
  strip_newline(tmp);

  if (tmptr->tm_isdst)
   isdst=1;
#ifdef BSD
  gmtoffset=(tmptr->tm_gmtoff/SECPERHR-isdst)*(-1);
  sprintf(newtime,"%s %s %d",tmp,tmptr->tm_zone,gmtoffset);
#else
  gmtoffset=(timezone/SECPERHR-isdst)*(-1);
  sprintf(newtime,"%s %s %d",tmp,tzname[isdst],gmtoffset);
#endif
  return(newtime);
}

void load_commands()
{
   FILE *fp;
   char buff[10000], *command= NULL, *funct= NULL, *level= NULL, *disable= NULL, *rest= NULL, cmds_out[150];
   int i = 0;

   buff[0]='\0';cmds_out[0]='\0';
   strcpy(buff, COM_FILE);
   if((fp = fopen(buff, "r")) == NULL)
   {
      file_error(buff);
      return;
   }
   while(fgets(buff, 100, fp) != NULL)
   {
      i = 0;
      if(buff[0] == '*') continue;
      strip_newline(buff);
      if(funct = strchr(buff, ' ')) *funct++ = '\0';
      while(*funct == ' ') *funct++;
      if(level = strchr(funct, ' ')) *level++ = '\0';
      while(*level == ' ') *level++;
      if(disable = strchr(level, ' ')) *disable++ = '\0';
      while(*disable == ' ') *disable++;
      if(rest = strchr(disable, ' '));
      for(i = 0; *commands[i].name; i++)
      {
         if(!strcasecmp(commands[i].name, funct))
         {
            strcpy(commands[i].name, buff);
            strcpy(commands[i].realname, funct);
            commands[i].level = atoi(level);
            commands[i].disable = atoi(disable);
         }
      }
   }
   fclose(fp);
}
