/* NS1 - Nick Services ns-src/parse_nick.c
 * NS1.2 Copyright  1998-2000 Chris Birch(IRCore)
 */

#include <bot.h>

void parse_nick(char *who, char *rest)
{
   struct nickinfo *current;
   struct rnickinfo *rnick;
   struct adderinfo *adder;
   int i = 0, found = 0, ns = 0;
   char buff[20], *base64;
   char *waste = NULL, *user = NULL, *host = NULL, *ptr = NULL, *reason = NULL, *jtime = NULL;
   char *what = NULL, *num = NULL,  *server = NULL, srv, *nwho = NULL, *uhost = NULL, delkill[100];


   if(who[0] == '\0')
   {
      if(waste = strchr(rest, ' ')) *waste++ = '\0';
      if(jtime = strchr(waste, ' ')) *jtime++ = '\0';
      if(user = strchr(jtime, ' ')) *user++ = '\0';
      if(host = strchr(user, ' ')) *host++ = '\0';
      if(ptr = strchr(host, ' ')) *ptr++ = '\0';
      if(ptr[0] == '+')
      {
         if(base64 = strchr(ptr, ' ')) *base64++ = '\0';
         if(num = strchr(base64, ' ')) *num++ = '\0';
         if(reason = strchr(num, ' ')) *reason++ = '\0';
	 reason++;
         server=num2serv(*num);
         if(*user == '~') user++;
	 strcpy(reason, ptr);
         add_nickinfo(rest, user, host, base64, num, server, reason);
         if(badnick(rest) == -1)
         {
            send_to_server(":%s NOTICE %s : You are using an illegal nick, you are being warned\n", bot.nick, num);
            send_to_server(":%s NOTICE %s : If you fail to change your nick, a kill will be issued in %d seconds\n", bot.nick, num, KILLINTERVAL);
            add_killinfo(rest, num, time(NULL));
            return;
         }
         rnick = rnickhead;
         uhost = getuserhost(rest);
         while(rnick != NULL)
         {
            if(!strcasecmp(rest, rnick->nick))
            {
               adder = rnick->adderhead;
               while(adder != NULL)
               {
                  if(!bancmp(adder->address, uhost))
                  {
                     found = 1;
                  }
                  adder = adder->next;
               }
               if(!found) 
               {
                  send_to_server(":%s NOTICE %s : You are using a Registered Nick\n", bot.nick, num);
                  send_to_server(":%s NOTICE %s : You are being warned \n", bot.nick, num);
                  if(!rnick->kills)
                     send_to_server(":%s NOTICE %s : that the registered owner has the ability to issue a kill to take it from you\n", bot.nick, num);
                  else
                  {
                     add_killinfo(rest, num, time(NULL));
                     send_to_server(":%s NOTICE %s : If you fail to change your nick, auto kill turned on, %d seconds to kill issued\n", bot.nick, num, KILLINTERVAL);
                  }
               }
	       if(found)
	       {
                  send_to_server(":%s NOTICE %s : You are recognized as userhost: %s\n" , bot.nick, num, uhost);
                  send_to_server(":%s NOTICE %s : which is linked to the nick you are using.\n", bot.nick, num);
                  send_to_server(":%s NOTICE %s : Please AUTH with NickServ to authenticate this nick.\n", bot.nick, num);
                  send_to_server(":%s NOTICE %s : Syntax: /msg %s AUTH <password>\n", bot.nick, num, bot.nick);
                  if(rnick->kills)
                  {
                     send_to_server(":%s NOTICE %s : You will be killed in %d seconds if you fail to auth\n", bot.nick, num, KILLINTERVAL);
                     add_killinfo(rest, num, time(NULL));
                  }
                  found = 0;
	       }
            }
            rnick = rnick->next;
         }
      }
      else
      {
         if(num = strchr(ptr, ' ')) *num++ = '\0';
         if(reason = strchr(num, ' ')) *reason++ = '\0';
	 reason++;
         server=num2serv(*num);
         if(*user == '~') user++;
         add_nickinfo(rest, user, host, ptr, num, server, reason);
         if(badnick(rest) == -1)
         {
            send_to_server(":%s NOTICE %s : You are using an illegal nick, you are being warned\n", bot.nick, num);
            send_to_server(":%s NOTICE %s : If you fail to change your nick, a kill will be issued in %d seconds\n", bot.nick, num, KILLINTERVAL);
            add_killinfo(rest, num, time(NULL));
            return;
         }
         rnick = rnickhead;
         uhost = getuserhost(rest);
         while(rnick != NULL)
         {
            if(!strcasecmp(rest, rnick->nick))
            {
               adder = rnick->adderhead;
               while(adder != NULL)
               {
                  if(!bancmp(adder->address, uhost))
                  {
                     found = 1;
                  }
                  adder = adder->next;
               }
               if(!found) 
               {
                  send_to_server(":%s NOTICE %s : You are using a Registered Nick\n", bot.nick, num);
                  send_to_server(":%s NOTICE %s : You are being warned\n", bot.nick, num);
                  if(!rnick->kills)
                     send_to_server(":%s NOTICE %s : that the registered owner has the ability to issue a kill to take it from you\n", bot.nick, num);
                  else
                  {
                     add_killinfo(rest, num, time(NULL));
                     send_to_server(":%s NOTICE %s : If you fail to change your nick, auto kill turned on, %d seconds to kill issued\n", bot.nick, num, KILLINTERVAL);
                  }
               }
	       if(found)
	       {
                  send_to_server(":%s NOTICE %s : You are recognized as userhost: %s\n" , bot.nick, num, uhost);
                  send_to_server(":%s NOTICE %s : which is linked to the nick you are using.\n", bot.nick, num);
                  send_to_server(":%s NOTICE %s : Please AUTH with NickServ to authenticate this nick.\n", bot.nick, num);
                  send_to_server(":%s NOTICE %s : Syntax: /msg %s AUTH <password>\n", bot.nick, num, bot.nick);
                  if(rnick->kills)
                  {
                     send_to_server(":%s NOTICE %s : You will be killed in %d seconds if you fail to auth\n", bot.nick, num, KILLINTERVAL);
                     add_killinfo(rest, num, time(NULL));
                  }
                  found = 0;
	       }
            }
            rnick = rnick->next;
         }
         refresh_registered(rest);
      }
   }
   else
   {
      /* who contains a nick */
      if(ptr = strchr(rest, ' ')) *ptr = '\0';
      nwho=num2nick(who);
      strcpy(delkill, nwho);
      if(badnick(rest) == -1)
      {
         send_to_server(":%s NOTICE %s : You are using an illegal nick, you are being warned\n", bot.nick, who);
         send_to_server(":%s NOTICE %s : If you fail to change your nick, a kill will be issued in %d seconds\n", bot.nick, who, KILLINTERVAL);
         add_killinfo(rest, who, time(NULL));
         replace_node(who, rest);
         return;
      }
      uhost = getuserhost(nwho);
      rnick = rnickhead;
      while(rnick != NULL)
      {
         if(!strcasecmp(rest, rnick->nick))
         {
            adder = rnick->adderhead;
            while(adder != NULL)
            {
               if(!bancmp(adder->address, uhost))
               {
                  found = 1;
               }
               adder = adder->next;
            }
            if(!found) 
            {
               send_to_server(":%s NOTICE %s : You are using a Registered Nick\n", bot.nick, who);
               send_to_server(":%s NOTICE %s : You are being warned\n", bot.nick, who);
               if(!rnick->kills)
                     send_to_server(":%s NOTICE %s : that the registered owner has the ability to issue a kill to take it from you\n", bot.nick, who);
               else
               {
                  add_killinfo(rest, who, time(NULL));
                  send_to_server(":%s NOTICE %s : If you fail to change your nick, auto kill turned on, %d seconds to kill issued\n", bot.nick, who, KILLINTERVAL);
               }
            }
            ns = 1;
            replace_node(who, rest);
            if(found && !is_auth(rest))
            {
               send_to_server(":%s NOTICE %s : You are recognized as userhost: %s\n" , bot.nick, who, uhost);
               send_to_server(":%s NOTICE %s : which is linked to the nick you are using.\n", bot.nick, who);
               send_to_server(":%s NOTICE %s : Please AUTH with NickServ to authenticate this nick.\n", bot.nick, who);
               send_to_server(":%s NOTICE %s : Syntax: /msg %s AUTH <password>\n", bot.nick, who, bot.nick);
               if(rnick->kills)
               {
                  send_to_server(":%s NOTICE %s : You will be killed in %d seconds if you fail to auth\n", bot.nick, who, KILLINTERVAL);
                  add_killinfo(rest, who, time(NULL));
               }
               found = 0;
            }
         }
         rnick = rnick->next;
      }
      delete_kill(delkill, who);
      if(ns != 1)
        replace_node(who, rest);
      refresh_registered(rest);
   }
}
