/* NS1 - Nick Services ns-src/parse_privmsg.c
 * NS1.2 Copyright  1998-2000 Chris Birch(IRCore)
 */

#include <bot.h>

void parse_privmsg(char *who, char *rest)
{
   int i = 0;
   char *msg = NULL, *cmd = NULL, *nwho = NULL;
   struct nickinfo *nick;

   if(!strcasecmp(who, bot.nick)) return;
   nwho=nick2num(who);
   if(check_flood(who)) return;  /* you flooding me? go away! */
   trailing_blanks(rest);        /* get rid of those trailing blanks */
   if(cmd = strchr(rest, ':')) *cmd++ = '\0';
   else return;
   if(msg = strchr(cmd, ' ')) *msg++ = '\0';
   else msg = NULL;
   for(i = 0; *commands[i].name; i++)
   {
      if(!strcasecmp(commands[i].name, cmd))
      {
         if(commands[i].level > 0)
           if(!check_access(who, msg, commands[i].level, cmd)) return;
         if(commands[i].needarg && msg == NULL) return;
         command_log(who, cmd, msg);
         commands[i].function(who, msg);
         return;
      }
   }
   if(!strcasecmp(who, uworldnick) || !strcasecmp(who, uworldhost) || !strcasecmp(who, chanserv) || !strcasecmp(who, chanhost)) return;
   send_to_server(":%s NOTICE %s :The Command [ %s ] is not a proper command.\n", bot.nick, nwho, cmd);
   send_to_server(":%s NOTICE %s :Please ensure you typed it correctly.\n", bot.nick, nwho);
}
