/* NS1 - Nick Services ns-src/server.c
 * NS1.2 Copyright  1998-2000 Chris Birch(IRCore)
 */

#include<bot.h>

int get_connection(char *hostname, int port)
{
   struct sockaddr_in sa;
   struct hostent *hp;
   int sckfd;
   if((hp = gethostbyname(hostname)) == NULL) 
   {
      errno = ECONNREFUSED;
      return(-1);
   }
   memset(&sa, 0, sizeof(sa));
   bcopy(hp->h_addr, (char *) &sa.sin_addr, hp->h_length);
   sa.sin_family = hp->h_addrtype;
   sa.sin_port = htons((u_short) port);
   if((sckfd = socket(hp->h_addrtype, SOCK_STREAM, 0)) < 0) return(-1);
   setsockopt(sckfd, SOL_SOCKET, SO_LINGER, 0, 0);
   setsockopt(sckfd, SOL_SOCKET, SO_REUSEADDR, 0, 0);
   setsockopt(sckfd, SOL_SOCKET, SO_KEEPALIVE, 0, 0);
   if(connect(sckfd, (struct sockaddr *) &sa, sizeof(sa)) < 0) 
   {
      close(sckfd);
      return(-1);
   }
   return(sckfd);
}

int readln()
{
   char ch;
   int i = 0;
   do 
   {
      if(read(socketfd, &ch, 1) < 1) return(0);
      if(ch >= 32 || ch <= 126)
         if(i < MAXLEN - 1) line[i++] = ch;
   } while(ch != '\n');
   line[i] = '\0';
   if(logging && !strstr(line, "AWAY") && !strstr(line, "@(!!)"))
      log(BOT_LOG, "R [%s] %s",date(), line);
#ifdef DEBUG
   printf("Read - %s\n", line);
#endif
   return 1;
}

int read_from_socket(int sock, char *buffer)
{
   char ch;
   int i = 0;
   do 
   {
      if(read(sock, &ch, 1) < 1) return(0);
      if(ch >= 32 || ch <= 126)
         if(i < MAXLEN - 1) buffer[i++] = ch;
   } while(ch != '\n');
   buffer[i] = '\0';
#ifdef DEBUG
   printf("Read from socket - %s\n", buffer);
#endif
   return 1;
}

int writeln(char *buffer)
{
   if(write(socketfd, buffer, strlen(buffer)) < 0) return(0);
   if(logging)
      log(BOT_LOG, "W [%s] %s",date(), buffer);
#ifdef DEBUG
   printf("Write - %s\n", buffer);
   if(msglog)
   {
      if(!strstr(buffer, "PRIVMSG"))
      {
         if(!strstr(buffer, "PING"))
         {
            if(!strstr(buffer, "NOTICE"))
            {
               messege_log(buffer);
            }
         }
      }
   }
#endif
}

int writeln2(int sock, char *buffer)
{
   if(write(sock, buffer, strlen(buffer)) < 0) return(0);
   return 1;
}

void sendping()
{
   send_to_server(":%s PING :%s\n", myserver, bot.server);
   bot.server_active = FALSE;  /* not active until PONG is received */
}

int send_to_socket(int sck, char *format, ...)
{
   va_list arglist;
   char buffer[MAXBUF];
   va_start(arglist, format);
   vsprintf(buffer, format, arglist);
   va_end(arglist);
   return(writeln2(sck, buffer));
}

void init_bot()
{
   int mypid;
   FILE *out;

   did_eoback = FALSE;
   joined = FALSE;
   strcpy(bot.nick, botnick);
   send_to_server("PASS %s\n", netpass);
   send_to_server("SERVER %s %d 0 %ld P10 %cD] :[%s] %s\n", myserver, HOPCOUNT + 1, time(NULL),
   convert2y[server_num], myhost,  reason);
   serv_used(convert2y[server_num], myserver);

   mypid = getpid();
   if (out = fopen(pid_file, "wt"))
   {
       fprintf(out, "%d\n", mypid);
       fclose(out);
   }
}

void reinit()
{
   char *usernum, *usernum1;

   usernum=get_free_usernum("N");
   usernum=get_free_usernum(bot.nick);
   send_to_server(":%s WALLOPS :Re-initialising Operator Service\n", myserver);
   send_to_server("%c NICK %s 1 780000000 %s %s DQx8MG %s :%s\n", convert2y[server_num], bot.nick, ircuser, myserver, usernum,ircname);
   send_to_server("%c NICK N 1 780000000 %s %s DQx8MG %s :%s\n", convert2y[server_num], ircuser, myserver, usernum1,ircname);
   send_to_server(":%s MODE %s %s\n", bot.nick, bot.nick, mymodes);
   join_msgchan();
}

int reconnect()
{
   char *botnum;

   if(bot.server_active == FALSE) 
   {
      botnum=get_usernum(bot.nick);
      delete_usernum(botnum);
      free_nicklist();
      close(socketfd); 
      return 0;
   }
   return 1;
}


void close_connection(char *who, char *rest)
{
   char buff[300], *chan;
   char *nwho = NULL;
   FILE *fp;
   int i = 0;

   nwho = nick2num(who);
   /* check if authed first */
   if (!is_auth(who))
   {
      send_to_server(":%s NOTICE %s : You are not authorized to use that command.\n", bot.nick, nwho);
      return;
   }
   send_to_server(":%s QUIT :%s squit by %s\n", bot.nick, bot.nick, who);
   send_to_server(":%s SQUIT %s :Just keeps getting better and better !\n", myserver, myserver);
   unlink(pid_file);
   exit(0);
}

/* this is the 'restart'command - again, for NS admins only */
void ns_restart(char *who, char *rest)
{
   char *nwho = NULL;

   nwho = nick2num(who);
   /* check if authed first */
   if (!is_auth(who))
   {
      send_to_server(":%s NOTICE %s : You are not authorized to use that command.\n", bot.nick, nwho);
      return;
   }

   /* next check if an admin */
   rehash();
}

